#include "common.h"

void dg_echo( int sockfd,                  // эхо-ретрансляция полученного от клиента 
              struct sockaddr* pcli_addr,  // указатель на sockaddr 
              socklen_t clilen ) {         // sizeof(*pcli_addr) 
   while( true ) {
      char recvline[ MAXLINE ];
      int n = recvfrom( sockfd, recvline, MAXLINE, 0, pcli_addr, &clilen );
      if( n < 0 ) err_dump( "dg_echo: recvfrom error" );
      if( sendto( sockfd, recvline, n, 0, pcli_addr, clilen ) != n )
         err_dump( "dg_echo: sendto error" );
      if( debug_level > 1 ) {
         fprintf( stdout, "%c", '.' ); 
         fflush( stdout );          
      }
   }
}

int main( int argc, char* argv[] ) {
   int c;
   while( -1 != ( c = getopt( argc, argv, "vh" ) ) )
      switch( c ) {
         case 'v':
            debug_level++;
            break;
         case 'h':
            fprintf( stderr, "%s [-vv...]\n", argv[ 0 ] );
            return( EXIT_SUCCESS );
         default:
            return( EXIT_FAILURE );         
      }
   if( debug_level )
      fprintf( stdout, "прослушивается UDP порт %d\n", SERV_UDP_PORT );         
   int sockfd;                             // открытие UDP сокета (an Internet datagram socket).
   if( ( sockfd = socket( AF_INET, SOCK_DGRAM, 0 ) ) < 0 )
      err_dump( "server: can't open datagram socket" );
   struct sockaddr_in serv_addr;           // подготовка серверного сокета
   bzero( (char*)&serv_addr, sizeof( serv_addr ) );
   serv_addr.sin_family      = AF_INET;
   serv_addr.sin_addr.s_addr = htonl( INADDR_ANY );
   serv_addr.sin_port        = htons( SERV_UDP_PORT );
   if( bind( sockfd, (struct sockaddr*)&serv_addr, sizeof( serv_addr ) ) < 0 )
      err_dump( "server: can't bind local address" );
   dg_echo( sockfd, (struct sockaddr*)&serv_addr, sizeof( serv_addr ) );
   exit( 0 );
}
